#ifndef LSM_STORE_INTERNAL
#define LSM_STORE_INTERNAL

#include <pthread.h>
#include <stdio.h>

#include "lsm/store.h"
#include "lsm/str_internal.h"
#include "lsm/trie.h"

typedef struct lsm_attr {
  lsm_attr_type type;
  lsm_str *str;
} lsm_attr;

struct lsm_entry {
  lsm_str *key;
  struct {
    uint64_t count;
    uint64_t bitmap;
    lsm_attr *items;
  } attrs;
  struct {
    uint64_t len;
    union {
      FILE *file;
      char *ptr;
    } value;
    bool on_disk;
  } data;
};

typedef struct lsm_entry_wrapper {
  pthread_rwlock_t lock;
  lsm_entry *entry;
} lsm_entry_wrapper;

lsm_error lsm_entry_wrapper_init(lsm_entry_wrapper **ptr);

struct lsm_store {
  lsm_trie *trie;
  lsm_str *data_path;
  lsm_str *db_path;
};

#endif
